# netbots.tcl v3.35 (16 June 2000)
# copyright (c) 1998-2000 by slennox <slennox@egghelp.org>
# slennox's eggdrop page - http://www.egghelp.org/

## botnetop.tcl component script v3.35.0 ##

proc bop_jointmr {nick uhost hand chan} {
  global bop_asktmr bop_delay botnick
  if {$nick != $botnick} {
    if {((![matchattr $hand b]) || (![matchattr $hand o|o $chan]) || ([matchattr $hand d|d $chan]))} {return 0}
    set stlchan [string tolower $chan]
    if {[info exists bop_asktmr($hand:$stlchan)]} {return 0}
    set bop_asktmr($hand:$stlchan) 1
    if {((!$bop_delay) || ([bop_lowbots $chan]))} {
      utimer 5 [split "bop_askbot $hand $chan"]
    } else {
      utimer [expr [rand $bop_delay] + 5] [split "bop_askbot $hand $chan"]
    }
  } else {
    bop_setneed $chan
  }
  return 0
}

proc bop_linkop {bot via} {
  global botnet-nick
  if {(($bot == ${botnet-nick}) || ($via == ${botnet-nick}))} {
    if {![string match *bop_linkreq* [utimers]]} {
      utimer 2 bop_linkreq
    }
  }
  return 0
}

proc bop_linkreq {} {
  foreach chan [channels] {
    if {(([botonchan $chan]) && (![botisop $chan]))} {
      bop_reqop $chan
    }
  }
  return
}

proc bop_reqop {chan} {
  foreach bot [chanlist $chan b] {
    if {(([isop $bot $chan]) && ([matchattr $bot o|o $chan]) && ([islinked [set hand [nick2hand $bot $chan]]]))} {
      putbot $bot "reqops $chan"
    }
  }
  return
}

if {$bop_modeop} {
proc bop_modeop {nick uhost hand chan mode opped} {
  global botnick
  if {(($mode == "+o") && (![botisop $chan]) && ($nick != $botnick) && ($opped != $botnick) && ([matchattr [set obot [nick2hand $opped $chan]] b]) && ([matchattr $obot o|o $chan]) && ([islinked $obot]))} {
    putbot $obot "reqops $chan"
  }
  return
}
}

proc bop_reqtmr {frombot cmd arg} {
  global bop_asktmr bop_delay
  set chan [lindex [split $arg] 0]
  if {![validchan $chan]} {return 0}
  if {((![matchattr $frombot b]) || (![matchattr $frombot o|o $chan]) || ([matchattr $frombot d|d $chan]))} {return 0}
  set stlchan [string tolower $chan]
  if {[info exists bop_asktmr($frombot:$stlchan)]} {return 0}
  set bop_asktmr($frombot:$stlchan) 1
  if {((!$bop_delay) || ([bop_lowbots $chan]))} {
    utimer 2 [split "bop_askbot $frombot $chan"]
  } else {
    utimer [expr [rand $bop_delay] + 2] [split "bop_askbot $frombot $chan"]
  }
  return 0
}

proc bop_askbot {hand chan} {
  global botnick bop_asktmr
  set stlchan [string tolower $chan]
  if {[info exists bop_asktmr($hand:$stlchan)]} {
    unset bop_asktmr($hand:$stlchan)
  }
  if {((![validchan $chan]) || (![botonchan $chan]) || (![botisop $chan]))} {return 0}
  if {((![matchattr $hand b]) || (![matchattr $hand o|o $chan]) || ([matchattr $hand d|d $chan]))} {return 0}
  if {![islinked $hand]} {return 0}
  putbot $hand "doyawantops $chan $botnick"
  return 0
}

proc bop_doiwantops {frombot cmd arg} {
  global bop_log bop_maxreq bop_opreqs botname botnick
  set chan [lindex [split $arg] 0] ; set fromnick [lindex [split $arg] 1]
  if {((![validchan $chan]) || (![botonchan $chan]) || ([botisop $chan]))} {return 0}
  set stlchan [string tolower $chan]
  if {(($bop_maxreq) && ($bop_opreqs($stlchan) >= $bop_maxreq))} {return 0}
  if {((![onchan $fromnick $chan]) || ([onchansplit $fromnick $chan]) || (![isop $fromnick $chan]))} {return 0}
  if {![matchattr [nick2hand $fromnick $chan] o|o $chan]} {return 0}
  if {![islinked $frombot]} {return 0}
  putbot $frombot "yesiwantops $chan $botnick [string trimleft [lindex [split $botname !] 1] "~+-^="]"
  incr bop_opreqs($stlchan)
  if {$bop_maxreq} {
    nb_killutimer "bop_opreqsreset $stlchan"
    utimer 30 [split "bop_opreqsreset $stlchan"]
  }
  if {$bop_log >= 2} {
    putlog "botnetop: requested ops from $frombot on $chan"
  }
  return 0
}

proc bop_botwantsops {frombot cmd arg} {
  global bop_addhost bop_log bop_osync strict-host
  set chan [lindex [split $arg] 0] ; set fromnick [lindex [split $arg] 1] ; set fromhost [lindex [split $arg] 2]
  if {((![botonchan $chan]) || (![botisop $chan]))} {return 0}
  if {((![onchan $fromnick $chan]) || ([onchansplit $fromnick $chan]))} {return 0}
  if {((![matchattr $frombot b]) || (![matchattr $frombot o|o $chan]) || ([matchattr $frombot d|d $chan]))} {return 0}
  if {(($fromhost != "") && ($fromhost != [string trimleft [getchanhost $fromnick $chan] "~+-^="]))} {return 0}
  if {![matchattr [nick2hand $fromnick $chan] o|o $chan]} {
    if {(($fromhost == "") || (!$bop_addhost))} {return 0}
    if {${strict-host} == 0} {
      set host *![string trimleft [getchanhost $fromnick $chan] "~+-^="]
    } else {
      set host *![getchanhost $fromnick $chan]
    }
    setuser $frombot HOSTS $host
    putlog "botnetop: added host $host to $frombot"
  }
  if {((!$bop_osync) && ([isop $fromnick $chan]))} {return 0}
  pushmode $chan +o $fromnick
  if {$bop_log >= 2} {
    if {$fromnick != $frombot} {
      putlog "botnetop: gave ops to $frombot (using nick $fromnick) on $chan"
    } else {
      putlog "botnetop: gave ops to $frombot on $chan"
    }
  }
  return 0
}

proc bop_letmein {needthis chan} {
  global botname botnick bop_log bop_needk bop_needi bop_needl bop_needu
  if {(([bots] == "") || ([botonchan $chan]))} {return 0}
  set stlchan [string tolower $chan]
  switch -exact -- $needthis {
    "needkey" {
      if {$bop_needk($stlchan)} {return 0}
      set reqlist ""
      foreach bot [bots] {
        if {((![matchattr $bot b]) || (![matchattr $bot o|o $chan]))} {continue}
        putbot $bot "wantkey $chan $botnick"
        lappend reqlist $bot
      }
      if {$bop_log >= 1 && $reqlist != ""} {
        regsub -all -- " " [join $reqlist] ", " reqlist
        putlog "botnetop: requested key for $chan from $reqlist"
      }
      set bop_needk($stlchan) 1
      utimer 30 [split "set bop_needk($stlchan) 0"]
    }
    "needinvite" {
      if {$bop_needi($stlchan)} {return 0}
      set reqlist ""
      foreach bot [bots] {
        if {((![matchattr $bot b]) || (![matchattr $bot o|o $chan]))} {continue}
        if {$botname != ""} {
          putbot $bot "wantinvite $chan $botnick [string trimleft [lindex [split $botname !] 1] "~+-^="]"
        } else {
          putbot $bot "wantinvite $chan $botnick"
        }
        lappend reqlist $bot
      }
      if {$bop_log >= 1 && $reqlist != ""} {
        regsub -all -- " " [join $reqlist] ", " reqlist
        putlog "botnetop: requested invite to $chan from $reqlist"
      }
      set bop_needi($stlchan) 1
      utimer 30 [split "set bop_needi($stlchan) 0"]
    }
    "needlimit" {
      if {$bop_needl($stlchan)} {return 0}
      set reqlist ""
      foreach bot [bots] {
        if {((![matchattr $bot b]) || (![matchattr $bot o|o $chan]))} {continue}
        putbot $bot "wantlimit $chan $botnick"
        lappend reqlist $bot
      }
      if {$bop_log >= 1 && $reqlist != ""} {
        regsub -all -- " " [join $reqlist] ", " reqlist
        putlog "botnetop: requested limit raise on $chan from $reqlist"
      }
      set bop_needl($stlchan) 1
      utimer 30 [split "set bop_needl($stlchan) 0"]
    }
    "needunban" {
      if {$bop_needu($stlchan)} {return 0}
      set reqlist ""
      foreach bot [bots] {
        if {((![matchattr $bot b]) || (![matchattr $bot o|o $chan]))} {continue}
        putbot $bot "wantunban $chan $botnick $botname"
        lappend reqlist $bot
      }
      if {$bop_log >= 1 && $reqlist != ""} {
        regsub -all -- " " [join $reqlist] ", " reqlist
        putlog "botnetop: requested unban on $chan from $reqlist"
      }
      set bop_needu($stlchan) 1
      utimer 30 [split "set bop_needu($stlchan) 0"]
    }
  }
  return 0
}

proc bop_botwantsin {frombot cmd arg} {
  global bop_icheck bop_log bop_who
  set chan [lindex [split $arg] 0]
  if {((![validchan $chan]) || (![botisop $chan]))} {return 0}
  if {((![matchattr $frombot b]) || (![matchattr $frombot fo|fo $chan]))} {return 0}
  set fromhost [lindex [split $arg] 2]
  switch -exact -- $cmd {
    "wantkey" {
      if {[string match *k* [lindex [split [getchanmode $chan]] 0]]} {
        putbot $frombot "thekey $chan [lindex [split [getchanmode $chan]] 1]"
        if {$bop_log >= 1} {
          putlog "botnetop: gave key for $chan to $frombot"
        }
      }
    }
    "wantinvite" {
      set fromnick [lindex [split $arg] 1]
      if {(($bop_icheck) && ($fromhost != ""))} {
        if {![info exists bop_who($fromnick)]} {
          set bop_who($fromnick) "$chan $frombot $fromhost"
          utimer 60 [split "bop_whounset $fromnick"]
        }
        putserv "WHO $fromnick"
      } else {
        putserv "INVITE $fromnick $chan"
        if {$bop_log >= 1} {
          if {$fromnick != $frombot} {
            putlog "botnetop: invited $frombot (using nick $fromnick) to $chan"
          } else {
            putlog "botnetop: invited $frombot to $chan"
          }
        }
      }
    }
    "wantlimit" {
      pushmode $chan +l [expr [llength [chanlist $chan]] + 1]
      if {$bop_log >= 1} {
        putlog "botnetop: raised limit on $chan as requested by $frombot"
      }
    }
    "wantunban" {
      foreach ban [chanbans $chan] {
        if {[string match [string tolower [lindex $ban 0]] [string tolower $fromhost]]} {
          pushmode $chan -b [lindex $ban 0]
          if {$bop_log >= 1} {
            putlog "botnetop: unbanned $frombot on $chan"
          }
        }
      }
    }
  }
  return 0
}

proc bop_who {from keyword arg} {
  global bop_log bop_who
  set fromnick [lindex [split $arg] 5]
  if {[info exists bop_who($fromnick)]} {
    set chan [lindex [split $bop_who($fromnick)] 0] ; set frombot [lindex [split $bop_who($fromnick)] 1] ; set fromhost [lindex [split $bop_who($fromnick)] 2]
    unset bop_who($fromnick)
    if {$fromhost == [string trimleft [lindex [split $arg] 2]@[lindex [split $arg] 3] "~+-^="]} {
      putserv "INVITE $fromnick $chan"
      if {$bop_log >= 1} {
        if {$fromnick != $frombot} {
          putlog "botnetop: invited $frombot (using nick $fromnick) to $chan"
        } else {
          putlog "botnetop: invited $frombot to $chan"
        }
      }
    }
  }
  return 0
}

proc bop_whounset {fromnick} {
  global bop_who
  if {[info exists bop_who($fromnick)]} {
    unset bop_who($fromnick)
  }
  return
}

proc bop_joinkey {frombot cmd arg} {
  global bop_kjoin
  set chan [lindex [split $arg] 0] ; set stlchan [string tolower $chan]
  if {(([botonchan $chan]) || ($bop_kjoin($stlchan)))} {return 0}
  putserv "JOIN $chan [lindex [split $arg] 1]"
  set bop_kjoin($stlchan) 1
  utimer 10 [split "set bop_kjoin($stlchan) 0"]
  return 0
}

proc bop_lowbots {chan} {
  global botnick
  set bots 1
  foreach bot [chanlist $chan b] {
    if {(($bot != $botnick) && ([isop $bot $chan]))} {
      incr bots
    }
  }
  if {$bots < 3} {return 1}
  return 0
}

proc bop_opreqsreset {stlchan} {
  global bop_opreqs
  set bop_opreqs($stlchan) 0
  return
}

proc bop_setneed {chan} {
  global bop_kjoin bop_needk bop_needi bop_needl bop_needu bop_opreqs
  set stlchan [string tolower $chan]
  channel set $chan need-op [split "bop_reqop $chan"]
  channel set $chan need-key [split "bop_letmein needkey $chan"]
  channel set $chan need-invite [split "bop_letmein needinvite $chan"]
  channel set $chan need-limit [split "bop_letmein needlimit $chan"]
  channel set $chan need-unban [split "bop_letmein needunban $chan"]
  set bop_opreqs($stlchan) 0 ; set bop_kjoin($stlchan) 0
  set bop_needk($stlchan) 0 ; set bop_needi($stlchan) 0
  set bop_needl($stlchan) 0 ; set bop_needu($stlchan) 0
  return
}

proc bop_settimer {} {
  foreach chan [channels] {
    if {![info exists bop_needi([string tolower $chan])]} {
      bop_setneed $chan
    }
  }
  if {![string match *bop_settimer* [timers]]} {
    timer 5 bop_settimer
  }
  return 0
}

if {![string match *bop_settimer* [utimers]]} {
  utimer 2 bop_settimer
}

bind mode - * bop_modeop
if {!$bop_modeop} {unbind mode - * bop_modeop}
bind link - * bop_linkop
if {!$bop_linkop} {unbind link - * bop_linkop}
bind bot - doyawantops bop_doiwantops
bind bot - yesiwantops bop_botwantsops
bind bot - reqops bop_reqtmr
bind bot - wantkey bop_botwantsin
bind bot - wantinvite bop_botwantsin
bind bot - wantlimit bop_botwantsin
bind bot - wantunban bop_botwantsin
bind bot - thekey bop_joinkey
bind join - * bop_jointmr
bind raw - 352 bop_who

return
